package JogoVida;

public class Grelha {
    private int linhas, colunas;
    private Celula grelha[][];

    public Grelha (int linhas, int colunas) {
        this.grelha = new Celula [linhas][colunas];
        for (int j = 0; j < linhas; j++)
            for (int i = 0; i < colunas; i++)
                this.grelha[j][i] = new Celula();        
        this.linhas = linhas;
        this.colunas = colunas;
    }

    public Grelha (Grelha g) {
        this.linhas = g.linhas();
        this.colunas = g.colunas();
        this.grelha = new Celula [this.linhas][this.colunas];
        for (int j = 0; j < this.linhas; j++)
            for (int i = 0; i < this.colunas; i++) {
                this.grelha[j][i] = new Celula();
                if (g.celula(j,i).viva())
                    (this.grelha[j][i]).nasce();
                else
                    (this.grelha[j][i]).morre();
            }
    }

    public Celula celula (int y, int x) {
        return this.grelha[(y+this.linhas)%this.linhas][(x+this.colunas)%this.colunas];
    }
    public void setCelula (int y, int x, Celula c) {
        this.grelha[(y+this.linhas)%this.linhas][(x+this.colunas)%this.colunas] = c;
    }

    public int vizinhos(int y, int x) {
        int ret = 0;
        if (this.celula(y-1,x-1).viva()) ret++;
        if (this.celula(y-1,x).viva()) ret++;
        if (this.celula(y-1,x+1).viva()) ret++;
        if (this.celula(y,x+1).viva()) ret++;
        if (this.celula(y+1,x+1).viva()) ret++;
        if (this.celula(y+1,x).viva()) ret++;
        if (this.celula(y+1,x-1).viva()) ret++;
        if (this.celula(y,x-1).viva()) ret++;
        return ret;
    }
    
    public int linhas() {
        return this.linhas;
    }
    public int colunas() {
        return this.colunas;
    }
}
