/*
 * Intruso.java
 *
 * Created on 24 de Dezembro de 2003, 9:38
 */

package JogoVida;
import java.util.Random;

/**
 *
 * @author  Bras
 */
public class Intruso extends Celula implements Runnable {
    private Thread t;
    private Universo u;
    private volatile int x,y,incx,incy;
    private volatile boolean keepRunning;
    
    
    /** Creates a new instance of Intruso */
    public Intruso(Universo u) {
        this.u=u;
        t=new Thread(this);
        this.keepRunning=false;
        t.start();
        t.suspend();
    }
    
    public void run() {
        this.runIntruso();
        //this.keepRunning=true;        
    }
    public void vaiPastar() {
        this.t.resume();
    }
    private void runIntruso() {   
        this.keepRunning=true;
        this.createIntruso();
        while(true) {
            if(!this.u.isMoving()) t.suspend();
            Random r = new Random();
            this.u.getCelula(x,y).setIntruso(false);
            incx=-1+(Math.abs(r.nextInt())%3);
            r.nextInt();
            incy=-1+(Math.abs(r.nextInt())%3);
            this.x+=incx;             
            this.y+=incy;
            if(this.x==0) this.x=this.u.getLinhas();
            if(this.y==0) this.y=this.u.getColunas();
            if(this.u.getCelula(x,y).viva()) this.u.getCelula(x,y).morre();
            this.u.getCelula(x,y).setIntruso(true);
            this.u.redesenhar();
            try {
                t.sleep(200);
            }
            catch (InterruptedException e) {//ignore
            };
        }
    }
    private void createIntruso() {
        boolean success=false;
        do {
        Random r = new Random();
        x = (Math.abs(r.nextInt()))%this.u.getColunas();
        r.nextInt();
        y = (Math.abs(r.nextInt()))%this.u.getLinhas();
        if(!this.u.getCelula(x,y).viva()) {
            success=true;
            this.u.getCelula(x,y).setIntruso(success);
            this.t.resume();
        }
        } while(!success);
    }
    public void morrePita() {
        this.u.getCelula(x,y).setIntruso(false);
        this.keepRunning=false;
        this.t.suspend();
    }
    
    
    public boolean estaViva() {
        return this.keepRunning;
    }
    
    
    public void createIntruso(int i, int j) {
        boolean success=false;
        do {
        
        x = (i)%this.u.getColunas();
        
        y = (j)%this.u.getLinhas();
        if(!this.u.getCelula(x,y).viva()) {
            success=true;
            this.u.getCelula(x,y).setIntruso(success);
            this.t.resume();
        }
        } while(!success);
    }
}