/*
 * Tiro.java
 *
 * Created on 18 de Dezembro de 2003, 16:43
 */

package JogoVida;

/**
 *
 * @author  Administrator
 */
public class Tiro extends Celula implements Runnable {
    private Thread t;
    private Universo u;
    private volatile int x,y,incx,incy,key;
    private volatile boolean keepRunning;
    /** Creates a new instance of Tiro */
    public Tiro(Universo u) {
        this.u=u;
        t=new Thread(this);    
        t.start();
        t.suspend();
    }    
    public void run() {         
        this.setNewTarget(key);
        this.startRunning();
        this.keepRunning=true;
    }    
    public void startRunning() {
        while(true) {
            this.u.getCelula(x,y).setTiro(false);
            this.x+=incx;             
            this.y+=incy;
            if(this.x==0) this.x=this.u.getLinhas();
            if(this.y==0) this.y=this.u.getColunas();
            if(this.u.getCelula(x,y).viva()) {
                this.u.setCelula(x-incx,y-incy);
                this.stopRunning();
            }
            if(this.u.getCelula(x,y).isIntruso()) {
                this.u.mataIntruso();
                this.stopRunning();
            }
            this.u.getCelula(x,y).setTiro(true);
            this.u.redesenhar();
            try {
                t.sleep(50);
            } catch (InterruptedException e) {
                //ignore
            }
        }
    }
    public void setNewTarget(int k) {        
        this.key=k;
        if(key==java.awt.event.KeyEvent.VK_RIGHT) {
            this.incy=1;
            this.incx=0;
        }
        if(key==java.awt.event.KeyEvent.VK_LEFT) {
            this.incy=-1;
            this.incx=0;
        }
        if(key==java.awt.event.KeyEvent.VK_UP) {
            this.incy=0;
            this.incx=-1;
        }
        if(key==java.awt.event.KeyEvent.VK_DOWN) {
            this.incy=0;
            this.incx=1;
        }
        this.x=this.u.getNaveX();
        this.y=this.u.getNaveY();
        if(this.x==0) this.x=this.u.getLinhas();
        if(this.y==0) this.y=this.u.getColunas();
        this.u.setTiro(x+incx,y+incy,true);
    }        
    public boolean isRunning() {
        return this.keepRunning;
    }
    public void stopRunning() {
        this.u.setTiro(x,y,false);
        this.t.suspend();
        this.keepRunning=false;
    }
    public void resumeRunning(int k) {
        this.u.setTiro(x,y,false);
        this.setNewTarget(k);
        this.t.resume();
        this.keepRunning=true;
    }
    
    public int getDirection(){
        return key;
    }
    
    
     public void setNewTarget(int k,int i,int j) {        
        this.key=k;
        if(key==java.awt.event.KeyEvent.VK_RIGHT) {
            this.incy=1;
            this.incx=0;
        }
        if(key==java.awt.event.KeyEvent.VK_LEFT) {
            this.incy=-1;
            this.incx=0;
        }
        if(key==java.awt.event.KeyEvent.VK_UP) {
            this.incy=0;
            this.incx=-1;
        }
        if(key==java.awt.event.KeyEvent.VK_DOWN) {
            this.incy=0;
            this.incx=1;
        }
        this.x=i;
        this.y=j;
        if(this.x==0) this.x=this.u.getLinhas();
        if(this.y==0) this.y=this.u.getColunas();
        this.u.setTiro(x+incx,y+incy,true);
    }   
     
     public void resumeTiro()
     { 
         t.resume();
     }
}
