package JogoVida;

import java.beans.*;
import java.awt.*;
import java.util.Random;
import JogoVida.*;
import javax.swing.*;
import java.math.*;

public class Universo extends Canvas implements java.io.Serializable {
    
    private Grelha grelha;
    private long geracao;
    private int xl,yt,inc;
    private int navex,navey,tirox,tiroy;
    private boolean isMoving;   
    private Tiro pim;
    private Intruso ovelhaNegra;
    private PropertyChangeSupport propertySupport;
    private BigInteiro pontuacao=new BigInteiro("000");
    int lastKey;
    
   
    public Universo() {
        propertySupport = new PropertyChangeSupport( this );
        this.grelha = null;
        this.lastKey=java.awt.event.KeyEvent.VK_RIGHT;
        this.pim=new Tiro(this);        
        this.ovelhaNegra=new Intruso(this);
        this.geracao=0;
    }
    public void setMoving(boolean x) {
       this.isMoving=x;
    }
    public boolean isMoving() {
        return this.isMoving;
    }
     public void mudaTamanho(int colunas, int linhas) {
      this.grelha = new Grelha(colunas, linhas);
    }
  
    public void popular(int quantidade) {
        Random r = new Random();
        for (int i = 0; i < quantidade+1;) {
	    int coluna = (Math.abs(r.nextInt()))%this.grelha.colunas();
	    for (int j = 0; j < 10; j++) 
                r.nextInt();
	    int linha = (Math.abs(r.nextInt()))%this.grelha.linhas();
	    Celula celula = this.grelha.celula(linha,coluna);
	    if (!celula.viva() && !celula.isNave()) {
                if(i==0) {
                    celula.setNave(true);                    
                }
                else celula.nasce();
                i++;    
	    }
        }
        this.isMoving=false;
    }
  
    public void paint(Graphics g) {
        if (this.grelha != null) {
	    Dimension d = this.getSize();
	  
	    float dx = d.width/this.grelha.colunas();
	    float dy = (d.height-100)/this.grelha.linhas();
	    inc = (int)(Math.min(dx,dy));
	  
	    xl = (int)((d.width-(this.grelha.colunas()*inc))/2);
	    yt = (int)((d.height-(this.grelha.linhas()*inc))/2);
	  
	    g.setPaintMode();
    	    g.setColor(Color.BLACK);
  	    g.fillRect(0,0,d.width,d.height);
  	    g.setColor(Color.YELLOW);
	    for (int i = 0; i <= this.grelha.colunas(); i++)
	        g.drawLine(xl+i*inc,yt,xl+i*inc,yt+this.grelha.linhas()*inc);
	    for (int i = 0; i <= this.grelha.linhas(); i++)
	        g.drawLine(xl,yt+i*inc,xl+this.grelha.colunas()*inc,yt+i*inc);
	    redesenhar();
        }
    }
  
    public void redesenhar() {
        Graphics gr = this.getGraphics();
        gr.setPaintMode();
        for (int j = 0; j < this.grelha.linhas(); j++)
	    for (int i = 0; i < this.grelha.colunas(); i++) {
	        Celula celula = this.grelha.celula(j,i);
	        if (celula.viva()) {
                    
	            gr.setColor(Color.RED);
                }
                else if(celula.isNave()) {
                    navex=j;
                    navey=i;
                    gr.setColor(Color.BLUE);
                }
                else if(celula.isTiro()) {
                    gr.setColor(Color.GREEN);
                }
                else if(celula.isIntruso()){
                    gr.setColor(Color.ORANGE);
                }
	        else
	            gr.setColor(Color.BLACK);
	        gr.fillRect(xl+i*inc+2,yt+j*inc+2,inc-3,inc-3);
	    }
    }
    public void proximaGeracao() {
        Grelha prev = new Grelha(this.grelha);      
        geracao++;
        for (int j = 0; j < this.grelha.linhas(); j++)
	    for (int i = 0; i < this.grelha.colunas(); i++) {
                if(geracao%10==0) this.createIntruso();            
                if(this.grelha.celula(j,i).explodiu()>0) {
                    this.paraJogo();                   
                    break;
                }
                
                else {
                    switch (prev.vizinhos(j,i)) {
                        /* 0 ou 1 vizinhos: morre de solidao */
                        /*                : permanece vazio  */
                        case 0:
                        case 1:
                            this.grelha.celula(j,i).morre();
                            break;
                        /* 2 vizinhos: continua do mesmo modo */
                        case 2:
                            break;
                        /* 3 vizinhos: se vazio, nasce  */
                        /*             senao, permanece */
                        case 3:
                            this.grelha.celula(j,i).nasce();
                            pontuacao.inc(); 
                            break;
                        /* 4+ vizinhos: morre de superpopulacao */
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                        case 8:
                            this.grelha.celula(j,i).morre();
                            break;
                    }
                }
	    }
    } 
    public boolean moveNave(int key) {
        if(this.grelha.celula(navex,navey).explodiu()>0) {
            return false;
        }
        if(this.isMoving) {
            if(key==java.awt.event.KeyEvent.VK_LEFT) {
                this.grelha.celula(navex,navey).setNave(false);
                navey-=1;
                this.grelha.celula(navex,navey).setNave(true);
                this.lastKey=key;
                return true;
            }
            if(key==java.awt.event.KeyEvent.VK_RIGHT) {
                this.grelha.celula(navex,navey).setNave(false);
                navey+=1;
                this.grelha.celula(navex,navey).setNave(true);
                this.lastKey=key;
                return true;
            }
            if(key==java.awt.event.KeyEvent.VK_UP) {
                this.grelha.celula(navex,navey).setNave(false);
                navex-=1;
                this.grelha.celula(navex,navey).setNave(true);
                this.lastKey=key;
                return true;
            }
            if(key==java.awt.event.KeyEvent.VK_DOWN) {
                this.grelha.celula(navex,navey).setNave(false);
                navex+=1;
                this.grelha.celula(navex,navey).setNave(true);
                this.lastKey=key;
                return true;
            }            
        }
        return true;
    }
    public void disparaTiro() {
        pim.stopRunning();
        pim.resumeRunning(lastKey);
    }
    public void paraJogo() {
        if(pim.isRunning()) 
            pim.stopRunning();
        if(ovelhaNegra.estaViva())
            ovelhaNegra.morrePita();
        this.isMoving=false;
        this.geracao=0;
        JOptionPane.showMessageDialog(this, "Voc Perdeu","Trabalho Final",JOptionPane.ERROR_MESSAGE);
    }
    public int getNaveX() {
        return this.navex;
    }
    public int getNaveY() {
        return this.navey;
    }
    public void setTiro(int x, int y, boolean o) {
        this.grelha.celula(x,y).setTiro(o);
        this.tirox=x;
        this.tiroy=y;
    }
    public int getLinhas() {
        return this.grelha.linhas();
    }
    public int getColunas() {
        return this.grelha.colunas();
    }
    public Celula getCelula(int x, int y) {
        return this.grelha.celula(x,y);
    }
    public void setCelula(int x, int y) {
        this.grelha.celula(x,y).nasce();
    }
    public void createIntruso() {
        if(!this.ovelhaNegra.estaViva()) 
            this.ovelhaNegra.vaiPastar();
    }
    
    public void createIntruso(int x, int y)
    {
        this.ovelhaNegra.createIntruso(x,y);
    }
    
    public void mataIntruso() {
        this.ovelhaNegra.morrePita(); 
    }
    
    public BigInteiro Pontuacao()
    {
        return this.pontuacao;
    }
    
      public Grelha getGrelha()
    {
        return this.grelha;
    }
      
      public void setGrelha(Grelha x){
        this.grelha = x;
      }
      
      public void setNavePos(int x,int y){
        this.navex=x;
        this.navey=y;
      }
      
      public void setTiroPos(int x,int y){
        this.tirox=x;
        this.tiroy=y;
      }
      
      public String getPontuacao(){
        return pontuacao.toString();
      }
      
     public Intruso getIntruso(){
         return this.ovelhaNegra;
     }
      
     public Tiro getTiro(){
        return this.pim;
     }
}


