import javax.swing.*;
import java.awt.*;
import JogoVida.*;

public class TrabFinal extends JFrame implements Runnable {
    private int times;
    public TrabFinal() {
        initComponents();
        this.gerador = new Gerador(this.universo);
        this.setExtendedState(this.MAXIMIZED_BOTH);
        this.btnComecar.setEnabled(false);
        this.t.start();
    }

    private void initComponents() {//GEN-BEGIN:initComponents
        panelComandos = new javax.swing.JPanel();
        btnNovo = new javax.swing.JButton();
        btnComecar = new javax.swing.JButton();
        btnSair = new javax.swing.JButton();
        btnSave = new javax.swing.JButton();
        btnLoad = new javax.swing.JButton();
        Pontuacao = new javax.swing.JLabel();
        universo = new JogoVida.Universo();

        setTitle("Trabalho Final");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        panelComandos.setLayout(new javax.swing.BoxLayout(panelComandos, javax.swing.BoxLayout.Y_AXIS));

        panelComandos.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                panelComandosMouseMoved(evt);
            }
        });

        btnNovo.setText("Novo");
        btnNovo.setMaximumSize(new java.awt.Dimension(96, 26));
        btnNovo.setMinimumSize(new java.awt.Dimension(96, 26));
        btnNovo.setPreferredSize(new java.awt.Dimension(96, 26));
        btnNovo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNovoActionPerformed(evt);
            }
        });

        panelComandos.add(btnNovo);

        btnComecar.setText("Come\u00e7ar");
        btnComecar.setMaximumSize(new java.awt.Dimension(96, 26));
        btnComecar.setMinimumSize(new java.awt.Dimension(96, 26));
        btnComecar.setPreferredSize(new java.awt.Dimension(96, 26));
        btnComecar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnComecarActionPerformed(evt);
            }
        });

        panelComandos.add(btnComecar);

        btnSair.setText("Sair");
        btnSair.setMaximumSize(new java.awt.Dimension(96, 26));
        btnSair.setMinimumSize(new java.awt.Dimension(96, 26));
        btnSair.setPreferredSize(new java.awt.Dimension(96, 26));
        btnSair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSairActionPerformed(evt);
            }
        });

        panelComandos.add(btnSair);

        btnSave.setText("Save");
        btnSave.setMaximumSize(new java.awt.Dimension(96, 26));
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });

        panelComandos.add(btnSave);

        btnLoad.setText("Load");
        btnLoad.setMaximumSize(new java.awt.Dimension(96, 26));
        btnLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLoadActionPerformed(evt);
            }
        });

        panelComandos.add(btnLoad);

        Pontuacao.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        Pontuacao.setMaximumSize(new java.awt.Dimension(96, 16));
        panelComandos.add(Pontuacao);

        getContentPane().add(panelComandos, java.awt.BorderLayout.WEST);

        universo.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                universoKeyPressed(evt);
            }
        });

        getContentPane().add(universo, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void btnLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLoadActionPerformed
        SaveLoad SL = new SaveLoad(this.universo);
        try
        {
            SL.Load();
            
            this.universo.setGrelha(SL.getGrelha());
            this.universo.redesenhar();
            
        }
        catch ( Exception e) { System.out.println(e.getMessage());}
    }//GEN-LAST:event_btnLoadActionPerformed

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
    SaveLoad SL = new SaveLoad(this.universo);       
        try
        {
            SL.Save();
        }
        catch ( Exception e)  { System.out.println(e.getMessage());}     
    }//GEN-LAST:event_btnSaveActionPerformed

    private void panelComandosMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_panelComandosMouseMoved

    }//GEN-LAST:event_panelComandosMouseMoved

    private void universoKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_universoKeyPressed
        int key=evt.getKeyCode();
        if(key==java.awt.event.KeyEvent.VK_SPACE) {
            this.universo.disparaTiro();
            //this.universo.createIntruso();
        }     
        
        
        this.universo.moveNave(key);
        this.universo.redesenhar();
        
        //if(this.grelha.celula(this.universo.naveX(),this.universo.naveY()).explodiu()) System.exit(0);
    }//GEN-LAST:event_universoKeyPressed

    private void btnNovoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNovoActionPerformed
        times++;
        this.btnNovo.setEnabled(false);
        this.btnComecar.setEnabled(true);
        //this.universo.paraJogo();
        try {
             this.universo.mudaTamanho(this.numLinhas, this.numColunas);
             try {
                 int numCelulas = new Integer(
                                          JOptionPane.showInputDialog(this, 
                                                                      "Nmero de Clulas Vivas")
                                      ).intValue();    
                 if (numCelulas > 0) 
                     this.universo.popular(numCelulas);
                 else 
                     JOptionPane.showMessageDialog(this, 
                                                   "Nmero de clulas deve ser maior que zero.", 
                                                   "Trabalho Final", 
                                                   JOptionPane.ERROR_MESSAGE); 
             } catch (Exception e) {
                 JOptionPane.showMessageDialog(this, 
                                                   "Erro no popular o universo.", 
                                                   "Trabalho Final", 
                                                   JOptionPane.ERROR_MESSAGE); 
             }    
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, 
                                          "Erro ao iniciar o jogo.", 
                                          "Trabalho Final", 
                                          JOptionPane.ERROR_MESSAGE); 
        } finally {
            this.universo.repaint();
        }
        this.universo.requestFocus();
    }//GEN-LAST:event_btnNovoActionPerformed

    private void btnComecarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnComecarActionPerformed
        this.btnComecar.setEnabled(false);
        this.btnNovo.setEnabled(true);
        this.universo.setMoving(true);
        this.gerador.startGerador();     
        this.universo.requestFocus();        
    }//GEN-LAST:event_btnComecarActionPerformed

    private void btnSairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSairActionPerformed
        System.exit(0);
    }//GEN-LAST:event_btnSairActionPerformed
    
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /*public void paint(Graphics g) {
        super.paint(g); // Para desenhar os componentes da Janela
        this.universo.desenhar();
    }*/
    

    public static void main(String args[]) {
        new TrabFinal().show();
    }
    public void disableComecar() {
        this.btnComecar.setEnabled(false);
    }
        
    public void run() {
        while (true) {
           this.Pontuacao.setText(this.universo.Pontuacao().toString());
          try { this.t.sleep(100); } catch (Exception e) {}
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel Pontuacao;
    private javax.swing.JButton btnComecar;
    private javax.swing.JButton btnLoad;
    private javax.swing.JButton btnNovo;
    private javax.swing.JButton btnSair;
    private javax.swing.JButton btnSave;
    private javax.swing.JPanel panelComandos;
    private JogoVida.Universo universo;
    // End of variables declaration//GEN-END:variables
    private boolean desenhar = false;
    private Gerador gerador;
    private Thread t = new Thread(this);
    
    private final int numLinhas = 25;
    private final int numColunas = 25;
}
